#pragma once

#include <include/vector.h>

typedef struct
{
  Vec2d position;
  Vec2d speed;
  int live;
  int leftSource;
  int stale;
} SimMissile;

typedef struct
{
  Vec2d* dot;
  SimMissile missile;
  int length;
  int player;
  double angle;
  double velocity;
} SimShot;

typedef struct
{
  SimShot* shot;
  int currentShot;
  Vec2d position;
  double angle;
  double velocity;
  double energy;
  double oldVelocity;
  int watch;
  int deaths;
  int kills;
  int shots;
  int active;
  int valid;
  int didShoot;
  int timeout;
  int timeoutcnt;
  char name[16];
} SimPlayer;

typedef struct
{
  Vec2d position;
  double radius;
  double mass;
} SimPlanet;
